image: maven:3.6.3-adoptopenjdk-11

stages:
  - build&test
  - package
  - dockerise
  - deploy

variables:
  MAVEN_OPTS: '-Dmaven.repo.local=.m2/repository'
  DOCKER_HOST: tcp://docker:2375
  DOCKER_DRIVER: overlay2
  DOCKER_TLS_CERTDIR: ''

cache:
  key: ${CI_COMMIT_REF_SLUG}
  paths:
    - .m2/repository

Build:
  stage: build&test
  script:
    - mvn $MAVEN_OPTS compile

Test:
  stage: build&test
  services:
    - docker:dind
  script:
    - mvn $MAVEN_OPTS test
  artifacts:
    paths:
      - zahlebom-impl/target/test-results/test/TEST-*.xml
    reports:
      junit: zahlebom-impl/target/test-results/test/TEST-*.xml

Package:
  image: adoptopenjdk/openjdk11:latest
  stage: package
  services:
    - docker:dind
  script:
    - ./mvnw -Pprod $MAVEN_OPTS package
  artifacts:
    paths:
      - zahlebom-impl/target/*.jar
    expire_in: 1 week

Dockerise:
  stage: dockerise
  image: docker:latest
  when: manual
  only:
    - tags
  services:
    - docker:dind
  script:
    - 'cp $(ls zahlebom-impl/target/*.jar) docker/gitlabci.jar'
    - cd docker
    - docker build -t $CI_REGISTRY_IMAGE:$CI_COMMIT_TAG -t $CI_REGISTRY_IMAGE:latest .
    - docker login -u gitlab-ci-token -p $CI_BUILD_TOKEN registry.gitlab.com
    - docker push $CI_REGISTRY_IMAGE:$CI_COMMIT_TAG
    - docker push $CI_REGISTRY_IMAGE:latest

#  You can define variables:
#     $HEROKU_USERNAME
#     $HEROKU_API_KEY
#     $HEROKU_PROJECT_NAME
#  in the environment variables of your GitLab repository
#Deploy to Heroku:
#  stage: deploy
#  image: docker:latest
#  services:
#    - docker:dind
#  when: manual
#  only:
#    - tags
#  script:
#    - docker login -u gitlab-ci-token -p $CI_BUILD_TOKEN registry.gitlab.com
#    - docker pull $CI_REGISTRY_IMAGE:$CI_COMMIT_TAG
#    - docker login --username=$HEROKU_USERNAME --password=$HEROKU_API_KEY registry.heroku.com
#    - docker tag $CI_REGISTRY_IMAGE:$CI_COMMIT_TAG registry.heroku.com/$HEROKU_PROJECT_NAME/web
#    - docker push registry.heroku.com/$HEROKU_PROJECT_NAME/web
#    - docker run --rm -e HEROKU_API_KEY=$HEROKU_API_KEY wingrunr21/alpine-heroku-cli container:release web --app $HEROKU_PROJECT_NAME

Deploy by SSH:
  stage: deploy
  image: alpine:latest
  when: manual
  only:
    - tags
  services:
    - docker:dind
  before_script:
    - apk update
    - apk add openssh-client
    - eval $(ssh-agent -s)
    - echo "$SSH_PRIVATE_KEY" | tr -d '\r' | ssh-add -
    - mkdir -p ~/.ssh
    - chmod 700 ~/.ssh
  script:
    - ssh -o StrictHostKeyChecking=no "$SERVER_SSH_LOGIN@$SERVER_ADDRESS" "cd $SERVER_PATH; docker-compose pull; docker-compose up -d"